
fragment float4 fragmentFunc(inputVertexType in [[stage_in]]
                                 ,texture2d<half> inputTex0 [[ texture(0) ]]
                                 ,texture2d<half> inputTex1 [[ texture(1) ]]
                                 ,texture2d<half> inputTex2 [[ texture(2) ]]
                                 ,texture2d<half> inputTex3 [[ texture(3) ]]
                                 ,texture2d<half> maskTex [[ texture(4) ]]
                                 ,constant planarUniforms& uniforms[[ buffer(0) ]]
)
{
    
#ifdef ARGB
    float4 outColor=textureFetchNearest(inputTex0, in.texCoordY).argb;
#endif
    
#ifdef ABGR
    float4 outColor=textureFetchNearest(inputTex0, in.texCoordY).abgr;
#endif

#ifdef BGRA
    float4 outColor=textureFetchNearest(inputTex0, in.texCoordY).bgra;
#endif
    
#ifdef RGBA
    float4 outColor=textureFetchNearest(inputTex0, in.texCoordY).rgba;
#endif
    
#ifdef FORCE_ALPHA
    outColor.a=1.0;
#endif
    
#ifndef NO_PREMULT
    outColor.rgb*=outColor.a;
#endif

#ifdef USE_MASK
    outColor.a*=textureFetchNearest(maskTex,in.maskCoord).a;
#endif
    
#ifdef USE_END_COLOR
    outColor=mix(uniforms.endColor,outColor,uniforms.endOpacity);
#endif
    return outColor;
}
