

vertex vertexOut vertexFunc(uint vertexID [[ vertex_id ]],const device txShaderVers* in[[ buffer(0) ]],constant txShaderUniforms& uniforms[[ buffer(3) ]])
{
    vertexOut out;

    out.position=in[vertexID].pos*uniforms.worldViewProj;

    out.tex1=in[vertexID].tex1;
	out.tex2=in[vertexID].tex2;
	out.texMask=in[vertexID].texMask;
    return out;
}

fragment float4 fragmentFunc(vertexOut in [[stage_in]]
							 ,texture2d<half> inputTex0 [[ texture(0) ]]
							 ,texture2d<half> inputTex1 [[ texture(1) ]]
							 ,texture2d<half> inputTexMask [[ texture(2) ]]
							 ,constant txShaderUniforms& uniforms[[ buffer(2) ]])
{
#ifdef PRE_MULT
	float4 outColor = float4(inputTex0.sample(linearSampler,in.tex1))*uniforms.transitionAlpha*uniforms.baseAlpha;
#else
    float4 outColor = float4(inputTex0.sample(linearSampler,in.tex1))*uniforms.baseAlpha;
    outColor.a=uniforms.transitionAlpha;
#endif
#ifdef USE_MASK
	outColor.a*=float(inputTexMask.sample(linearSampler,in.texMask).a);
#endif
	return outColor;
}
