
//#include "metalShaderTypes.h"

typedef struct
{
	float4 burnColor;
} fxVars;

float rand (vec2 co)
{
    return fract(sin(dot(co.xy ,vec2(12.9898,78.233))) * 43758.5453);
}

float Gaussian(float p, float center, float c)
{
    return 0.575 * exp(- pow((p - center) / c, 2.));
}


vertex vertexOut vertexFunc(uint vertexID [[ vertex_id ]],const device txShaderVers* in[[ buffer(0) ]],constant txShaderUniforms& uniforms[[ buffer(3) ]],constant fxVars& vars[[ buffer(2)]])
{
    vertexOut out;

    out.position=in[vertexID].pos*uniforms.worldViewProj;

    out.tex1=in[vertexID].tex1;
	out.tex2=in[vertexID].tex2;
	out.texMask=in[vertexID].texMask;
    return out;
}

fragment float4 fragmentFunc(vertexOut in [[stage_in]]
							 ,texture2d<half> inputTex0 [[ texture(0) ]]
							 ,texture2d<half> inputTex1 [[ texture(1) ]]
							 ,texture2d<half> inputTexMask [[ texture(2) ]]
							 ,constant txShaderUniforms& u[[ buffer(2) ]]
							 ,constant fxVars& vars[[ buffer(1)]])
{
	vec2 p = in.tex1;
	vec2 p2 = in.tex2;

	float c = cos(Gaussian(u.transitionProgressLinear * (1. + Gaussian(u.transitionProgressLinear * rand(p), 0.5, 0.5)), 0.5, 0.5));
	float c2 = cos(Gaussian(u.transitionProgressLinear * (1. + Gaussian(u.transitionProgressLinear * rand(p2), 0.5, 0.5)), 0.5, 0.5));
	vec2 d = p * c;
	vec2 d2 = p2 * c2;

	vec4 colorA=tex(inputTex0,d);
	vec4 colorB=tex(inputTex1,d2);
	float4 outColor=mix(colorB,colorA,u.transitionProgressLinear);

#ifdef USE_MASK
	outColor.a*=float(inputTexMask.sample(linearSampler,in.texMask).a);
#endif

	return outColor;
}
